#
# Conditional build:
%bcond_without	tests		# build without tests

Summary:	Memory-mapped key-value database
Summary(pl.UTF-8):	Baza danych klucz-wartość odwzorowywana w pamięci
Name:		lmdb
Version:	0.9.31
Release:	1
License:	OpenLDAP
Group:		Applications/Databases
#Source0Download: https://github.com/LMDB/lmdb/releases
Source0:	https://github.com/LMDB/lmdb/archive/LMDB_%{version}.tar.gz
# Source0-md5:	9d7f059b1624d0a4d4b2f1781d08d600
Source1:	%{name}.pc.in
Patch0:		%{name}-make.patch
URL:		http://symas.com/mdb/
BuildRequires:	doxygen
BuildRequires:	rpm-build >= 4.6
Requires:	%{name}-libs = %{version}-%{release}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
LMDB is an ultra-fast, ultra-compact key-value embedded data store
developed by for the OpenLDAP Project. By using memory-mapped files,
it provides the read performance of a pure in-memory database while
still offering the persistence of standard disk-based databases, and
is only limited to the size of the virtual address space.

%description -l pl.UTF-8
LMDB to bardzo szybka i zwarta, wbudowana baza danych klucz-wartość
rozwijana dla projektu OpenLDAP. Dzięki użyciu plików odwzorowywanych
w pamięci zapewnia wydajność odczytu analogiczną do bazydanych
trzymanej w pamięci, oferując jednocześnie trwałość charakterystyczną
dla baz opartych na dysku oraz ograniczenie wyłącznie rozmiarem
wirtualnej przestrzeni adresowej.

%package libs
Summary:	LMDB shared library
Summary(pl.UTF-8):	Biblioteka współdzielona LMDB
Group:		Libraries

%description libs
This package contains the shared library necessary for running
applications that use LMDB.

%description libs -l pl.UTF-8
Ten pakiet zawiera bibliotekę współdzieloną konieczną do uruchamiania
aplikacji wykorzystujących LMDB.

%package devel
Summary:	Header files for LMDB library
Summary(pl.UTF-8):	Plik nagłówkowy LMDB
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}

%description devel
This package contains the header file for developing applications that
use LMDB.

%description devel -l pl.UTF-8
Ten pakiet zawiera plik nagłówkowy do tworzenia aplikacji
wykorzystujących LMDB.

%package static
Summary:	Static LMDB library
Summary(pl.UTF-8):	Statyczna biblioteka LMDB
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static LMDB library.

%description static -l pl.UTF-8
Statyczna biblioteka LMDB.

%package apidocs
Summary:	LMDB API documentation
Summary(pl.UTF-8):	Dokumentacja API biblioteki LMDB
Group:		Documentation
BuildArch:	noarch

%description apidocs
LMDB API documentation.

%description apidocs -l pl.UTF-8
Dokumentacja API biblioteki LMDB.

%prep
%setup -q -n %{name}-LMDB_%{version}
%patch0 -p1

%{__mv} libraries/liblmdb/* .

%build
%{__make} \
	CC="%{__cc}" \
	OPT= \
	XCFLAGS="%{rpmcflags} %{rpmcppflags}" \
	LDFLAGS="%{rpmldflags}"

%if %{with tests}
rm -rf testdb
LD_LIBRARY_PATH=$PWD %{__make} test
%endif

# Build doxygen documentation
doxygen

%install
rm -rf $RPM_BUILD_ROOT

# make install expects existing directory tree
install -d $RPM_BUILD_ROOT{%{_bindir},%{_includedir},%{_libdir},%{_mandir}/man1,%{_pkgconfigdir}}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	prefix=%{_prefix} \
	libdir=%{_libdir}

# rename to have typical 0.0.0 file
ln -sf liblmdb.so.0.0.0 $RPM_BUILD_ROOT%{_libdir}/liblmdb.so
%{__mv} $RPM_BUILD_ROOT%{_libdir}/liblmdb.so.{0,0.0.0}
/sbin/ldconfig -n  $RPM_BUILD_ROOT%{_libdir}

%{__sed} -e 's:@PREFIX@:%{_prefix}:g' \
	-e 's:@EXEC_PREFIX@:%{_exec_prefix}:g' \
	-e 's:@LIBDIR@:%{_libdir}:g' \
	-e 's:@INCLUDEDIR@:%{_includedir}:g' \
	-e 's:@PACKAGE_VERSION@:%{version}:g' \
	%{SOURCE1} >$RPM_BUILD_ROOT%{_pkgconfigdir}/lmdb.pc

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/mdb_copy
%attr(755,root,root) %{_bindir}/mdb_dump
%attr(755,root,root) %{_bindir}/mdb_load
%attr(755,root,root) %{_bindir}/mdb_stat
%{_mandir}/man1/mdb_copy.1*
%{_mandir}/man1/mdb_dump.1*
%{_mandir}/man1/mdb_load.1*
%{_mandir}/man1/mdb_stat.1*

%files libs
%defattr(644,root,root,755)
%doc CHANGES COPYRIGHT LICENSE
%attr(755,root,root) %{_libdir}/liblmdb.so.*.*.*
%ghost %{_libdir}/liblmdb.so.0

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/liblmdb.so
%{_includedir}/lmdb.h
%{_pkgconfigdir}/lmdb.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/liblmdb.a

%files apidocs
%defattr(644,root,root,755)
%doc html/*
%changelog
* Tue Jul 11 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/lmdb.git;a=log;h=master

* Tue Jul 11 2023 Jan Palus <atler@pld-linux.org> 269db30
- up to 0.9.31

* Fri Apr 15 2022 Jan Palus <atler@pld-linux.org> 3ecb54d
- reset OPT flags, add LDFLAGS

* Fri Apr 15 2022 Jan Palus <atler@pld-linux.org> 32363b0
- rpm version for noarch subpackage

* Fri Apr 15 2022 Jan Palus <atler@pld-linux.org> ba1ef51
- up to 0.9.29

* Sun Feb 28 2021 Jan Rękorajski <baggins@pld-linux.org> 9af0b14
- unconditional noarch subpackages

* Wed Jul 31 2019 Jakub Bogusz <qboosh@pld-linux.org> daa7ea8
- updated to 0.9.24
- added .pc file (based on Fedora)

* Tue Dec 25 2018 Jakub Bogusz <qboosh@pld-linux.org> a135ffc
- updated to 0.9.23

* Wed Apr 25 2018 Jakub Bogusz <qboosh@pld-linux.org> f0ac144
- updated to 0.9.22
- updated make patch

* Wed Oct 05 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 53e63b1
- rel 3; make .so a symlink

* Sun Jul 03 2016 Elan Ruusamäe <glen@delfi.ee> 7c8b7f2
- noarch apidocs

* Thu Jun 30 2016 Jakub Bogusz <qboosh@pld-linux.org> 02fa58e
- updated to 0.9.18
- updated make patch
- pl
- added -static and -apidocs subpackages

* Sun Sep 06 2015 Elan Ruusamäe <glen@delfi.ee> ef89d8a
- fix SONAME

* Sun Sep 06 2015 Elan Ruusamäe <glen@delfi.ee> 714e964
- simplify build tree, add more doc

* Sun Sep 06 2015 Elan Ruusamäe <glen@delfi.ee> 8633c44
- pldize

* Fri Sep 04 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 6c44fb5
- add patch

* Fri Sep 04 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> d288b91
- initial

